/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package controller;

import java.io.*;
import java.net.*;

import javax.servlet.*;
import javax.servlet.http.*;

import middletier.*;

/**
 *
 * @author gdestri
 */
public class RubricaServlet extends HttpServlet {
   
    // ATTRIBUTI DAL MODEL
    PersonDataCache pdt = new PersonDataCache();
    QueryContainer dbw = new QueryContainer();
    
    // COSTANTI LOCALI AL SERVLET
    private final static String TOTAL_RECORD_MESSAGE = "Numero totale di record: ";
    private final static String CURRENT_CURSOR_MESSAGE = "Record corrente:";

    
    /** Initializes the servlet.
     */
    public void init(ServletConfig config) throws ServletException {
        super.init(config);
        
    }
    
    /** Destroys the servlet.
     */
    public void destroy() {
        pdt = null;
        dbw = null;
    }
    
    /** Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        
        // oggetto di tipo Persona usato nelle operazioni
        Person temporaneo = null;
        
        // URL della view
        String viewURL = "rubrica.jsp";
        
        // riceve i parametri dalla form HTML come variabili stringa
        String nomeString = request.getParameter("txtNome");
        String cognomeString = request.getParameter("txtCognome");
        String codiceString = request.getParameter("txtCodice");
        
        // caso di ricerca per nome
        if (request.getParameter("btnNome")!=null) {
            try {
                pdt.setPersonList(dbw.cercaPerNome(nomeString));
                temporaneo = pdt.getFirst();
            } catch(Exception eccezione) {
                temporaneo = new Person("","NOT FOUND","");
            } // end catch
        }

        // caso di ricerca per cognome
        if (request.getParameter("btnCognome")!=null) {
            try {
                pdt.setPersonList(dbw.cercaPerCognome(cognomeString));
                temporaneo = pdt.getFirst();
            } catch(Exception eccezione) {
                temporaneo = new Person("","NOT FOUND","");
            } // end catch
        }

        // caso di ricerca per num tel
        if (request.getParameter("btnCodice")!=null) {
            try {
                pdt.setPersonList(dbw.cercaPerCodice(codiceString));
                temporaneo = pdt.getFirst();
            } catch(Exception eccezione) {
                temporaneo = new Person("","NOT FOUND","");
            } // end catch
        }

        // caso di avanzamento nel recordset
        if (request.getParameter("btnNext")!=null) {
            temporaneo = pdt.getNext();
            if (temporaneo == null) {
                temporaneo = new Person("","NOT FOUND","");
            } // end if null
        }
        
        // caso di arretramento nel recordset
        if (request.getParameter("btnPrev")!=null) {
            temporaneo = pdt.getPrev();
            if (temporaneo == null) {
                temporaneo = new Person("","NOT FOUND","");
            } // end if null
        }

        // richiesta del primo elemento
        if (request.getParameter("btnFirst")!=null) {
            temporaneo = pdt.getFirst();
            if (temporaneo == null) {
                temporaneo = new Person("","NOT FOUND","");
            } // end if null
        }

        // richiesta dell'ultimo elemento
        if (request.getParameter("btnLast")!=null) {
            temporaneo = pdt.getLast();
            if (temporaneo == null) {
                temporaneo = new Person("","NOT FOUND","");
            } // end if null
        }

        // richiesta di inserimento
        if (request.getParameter("btnInsert")!=null) {
            if ((nomeString != null) && 
                (cognomeString != null) &&
                 (codiceString != null)) {
                 temporaneo = new Person(nomeString, cognomeString, codiceString);
                 dbw.insertInDB(temporaneo);
            }
        }
        
        // richiesta di update
        if (request.getParameter("btnUpdate") != null) {
            if ((nomeString != null) && 
                (cognomeString != null) &&
                 (codiceString != null)) {
                 temporaneo = new Person(nomeString, cognomeString, codiceString);
                 Person key = pdt.getElementAt(pdt.getCursorIndex());
                 dbw.updateInDB(temporaneo, key);
            }            
        }
        
        // richiesta di delete
        if (request.getParameter("btnDelete") != null) {
            if ((nomeString != null) && 
                (cognomeString != null) &&
                 (codiceString != null)) {
                 temporaneo = new Person(nomeString, cognomeString, codiceString);
                 dbw.deleteFromDB(temporaneo);
            }            
        }
        
        // rileva il numero di record presenti in memoria
        String numRecordString=new String(Integer.toString(pdt.size()));
        
        // rileva la posizione corrente
        String corPosString=new String(Integer.toString(pdt.getCursorIndex()+1));
     
        // aggancia la variabile alla request con identificatore "numRecord" e "corPos"
        request.setAttribute("numRecord", numRecordString);
        request.setAttribute("corPos", corPosString);
        
        // aggancia l'oggetto alla request con identificatore "PersonObj"
        request.setAttribute("personObj", temporaneo);
        
        // e passa il controllo alla pagina JSP
        request.getRequestDispatcher(viewURL).forward(request, response);

    } // end method processRequest
    
    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
    * Handles the HTTP <code>GET</code> method.
    * @param request servlet request
    * @param response servlet response
    */
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    } 

    /** 
    * Handles the HTTP <code>POST</code> method.
    * @param request servlet request
    * @param response servlet response
    */
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
    * Returns a short description of the servlet.
    */
    public String getServletInfo() {
        return "Short description";
    }
    // </editor-fold>
}
