/*
 * QueryContainer.java
 *
 * Created on 1 dicembre 2006, 0.29
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package middletier;

import java.util.*;
import java.sql.*;
import java.io.*;

import access.DbConnector;

/**
 *
 * @author gdestri
 */
public class QueryContainer {
    
    private DbConnector dbConnector;
    private static Connection dbConn;
    
    /** Creates a new instance of QueryContainer 
      * Crea anche il connector e gli chiede la connessione al DB
      */
    public QueryContainer() {
        dbConnector = new DbConnector();
        dbConn = dbConnector.getConnection();
    }
    
    public Vector loadAllFromDB() {
        Person temporaneo = null;
        Vector listaPersone = new Vector();
        String totalQuery = "SELECT FIRSTNAME, LASTNAME, CODE FROM PERSON";
        ResultSet rs;
	int numCols;
	int numRows;
	int row = 1;

	try {
		// crea lo statement
		PreparedStatement pstmt = dbConn.prepareStatement(totalQuery);

		// applica la query ed ottiene il resultset
		rs = pstmt.executeQuery ();
                           
		// conta le colonne presenti
		numCols = rs.getMetaData().getColumnCount();

		// stampa i nomi delle colonne presenti su stdout
		for (int col=1; col<=numCols; col++) {
                    System.out.print(rs.getMetaData().getColumnName(col) + " | "); 	
		}
		System.out.println("|");
                
                                
                //ricerca per tutto il resultset
		// legge tutte le righe del ResultSet
		while (rs.next()) { 	
                    // costruisce l'oggetto Person contenente i dati dell'ultimo record trovato
                    temporaneo = new Person(rs.getString(1),rs.getString(2),rs.getString(3));
                    /*
                    for (int col=1; col<=numCols; col++) { 	
			  String string = rs.getString (col);
	 	 	  System.out.print(string + " | "); 
			}
	 		System.out.println("");
	 		row ++;
                     */
                    listaPersone.add(temporaneo);
		} // end while
                 
		
	} catch (SQLException sqle) { // SQL exception
	      System.err.println("Errore Fatale: non e' possibile interrogare il DB:" 
                                    + dbConnector.getDBName());
	      // System.exit(-3);
	}
        
        return listaPersone;
    } // end caricaRubricaDB


      public void insertInDB(Person p_person) {
          
          String totalQuery = "INSERT INTO PERSON (FIRSTNAME, LASTNAME, CODE) VALUES (?,?,?) ";
          
          try {
              // crea lo statement
              PreparedStatement pstmt = dbConn.prepareStatement(totalQuery);
                  
              pstmt.setString(1,p_person.getFirstName());
              pstmt.setString(2,p_person.getLastName());
              pstmt.setString(3,p_person.getCode());

              // applica l'insert
              int numRis = pstmt.executeUpdate ();
              System.out.println("Inserimento Esegeguito Correttamente");
          
          } catch (SQLException sqle) { // SQL exception
              System.err.println("Errore Fatale --- non possibile inserire:"+ dbConnector.getDBName());
              System.err.println(sqle.getMessage());
              sqle.printStackTrace();
          } // end catch       
             
      } // end insertInDB


      public void deleteFromDB(Person p_person) {
          
          String totalQuery = "DELETE FROM PERSON WHERE (FIRSTNAME=?) and (LASTNAME=?) and (CODE=?) ";
          
          try {
              // crea lo statement
              PreparedStatement pstmt = dbConn.prepareStatement(totalQuery);
                 
              // inserisce gli elementi per la ricerca del dato da rimuovere
              pstmt.setString(1,p_person.getFirstName());
              pstmt.setString(2,p_person.getLastName());
              pstmt.setString(3,p_person.getCode());
                  
              // applica il delete
              pstmt.executeUpdate ();
              System.out.println("Cancellazione Esegeguita Correttamente");
          
          } catch (SQLException sqle) { // SQL exception
              System.err.println("Errore Fatale --- non possibile Cancellare il dato in:"+ dbConnector.getDBName());
          } // end catch        
          
      } // end deleteFromDB
      
      
      public void updateInDB(Person p_person_value, Person p_person_key) {
          
          String totalQuery = "UPDATE PERSON SET FIRSTNAME=?, LASTNAME=?, CODE=? WHERE (FIRSTNAME=?) and (LASTNAME=?) and (CODE=?)";
              
          try {
              // crea lo statement
              PreparedStatement pstmt = dbConn.prepareStatement(totalQuery);
                  
              // imposta nell'istruzione i valori da inserire
              pstmt.setString(1,p_person_value.getFirstName());
              pstmt.setString(2,p_person_value.getLastName());
              pstmt.setString(3,p_person_value.getCode());
                  
              // inserisce i parametri per la ricerca dell'elemento da sostituire
              pstmt.setString(4,p_person_key.getFirstName());
              pstmt.setString(5,p_person_key.getLastName());
              pstmt.setString(6,p_person_key.getCode());
                  
              // applica la query ed ottiene il resultset
              pstmt.executeUpdate ();
              System.out.println("Rimpiazzamento Esegeguito Correttamente");
          
         } catch (SQLException sqle) { // SQL exception
              System.err.println("Errore Fatale --- non possibile aggiornamento:"+ dbConnector.getDBName());
         } // end catch
         
      } // end method updateInDB    
      
      
      
      public Vector caricaTutti() {
          Person temporaneo = null;
          Vector listaPersone = new Vector();
          String totalQuery = "SELECT FIRSTNAME, LASTNAME, CODE FROM PERSON order by ID";
          ResultSet rs;
          int numCols;
          int numRows;
          int row = 1;

          try {
                  // crea lo statement
                  PreparedStatement pstmt = dbConn.prepareStatement(totalQuery);
                  
                  // applica la query ed ottiene il resultset (con TUTTI i record della tabella!)
                  rs = pstmt.executeQuery ();                  
                  
                  // conta le colonne presenti
                  numCols = rs.getMetaData().getColumnCount();

                  // stampa i nomi delle colonne presenti su stdout
                  for (int col=1; col<=numCols; col++) {
                      System.out.print(rs.getMetaData().getColumnName(col) + " | ");      
                  }
                  System.out.println("|");
                  
                                  
                  //ricerca per tutto il resultset
                  // legge tutte le righe del ResultSet
                  while (rs.next()) {     
                      // costruisce l'oggetto Persona contenente i dati dell'ultimo record trovato
                      temporaneo = new Person(rs.getString(1),rs.getString(2),rs.getString(3));
                      /*
                      for (int col=1; col<=numCols; col++) {      
                            String string = rs.getString (col);
                            System.out.print(string + " | "); 
                          }
                          System.out.println("");
                          row ++;
                       */
                       // lo aggiunge in fondo al vector
                      listaPersone.add(temporaneo);
                  } // end while
                   
                  
          } catch (SQLException sqle) { // SQL exception
                System.err.println("Errore Fatale --- non possibile interrogare il DB:"+ dbConnector.getDBName());
                // System.exit(-3);
          }
          
          // se il risultato e' ancora null
          if (temporaneo==null){
              // viene lanciata un'eccezione
              System.err.println("Errore: nessun record trovato");
//              RubricaException eccezione;
//              eccezione= new RubricaException("Non ho trovato nulla!",RubricaException.NOT_FOUND);
//              throw eccezione;
          } // end if (res==null)
          
          return listaPersone;
      } // end caricaRubricaDB
      
      public Vector cercaPerNome(String p_nome) {
          Person temporaneo = null;
          Vector listaPersone = new Vector();
          String totalQuery = "SELECT FIRSTNAME, LASTNAME, CODE FROM PERSON where FIRSTNAME = ?";
          ResultSet rs;
          int numCols;
          int numRows;
          int row = 1;

          try {
                  // crea lo statement
                  PreparedStatement pstmt = dbConn.prepareStatement(totalQuery);
                  
                  // inserisce l'argomento, con i wildcard del DB agli estremi 
                  // (ricerca per sottostringa)
                  pstmt.setString(1,p_nome);

                  // applica la query ed ottiene il resultset
                  rs = pstmt.executeQuery ();
                  
                  
                  // conta le colonne presenti
                  numCols = rs.getMetaData().getColumnCount();

                  // stampa i nomi delle colonne presenti su stdout
                  for (int col=1; col<=numCols; col++) {
                      System.out.print(rs.getMetaData().getColumnName(col) + " | ");      
                  }
                  System.out.println("|");
                  
                                  
                  //ricerca per tutto il resultset
                  // legge tutte le righe del ResultSet
                  while (rs.next()) {     
                      // costruisce l'oggetto Persona contenente i dati dell'ultimo record trovato
                      temporaneo = new Person(rs.getString(1),rs.getString(2),rs.getString(3));
                      /*
                      for (int col=1; col<=numCols; col++) {      
                            String string = rs.getString (col);
                            System.out.print(string + " | "); 
                          }
                          System.out.println("");
                          row ++;
                       */
                      listaPersone.add(temporaneo);
                  } // end while
                   
                  
          } catch (SQLException sqle) { // SQL exception
                System.err.println("Errore Fatale --- non possibile interrogare il DB:"+ dbConnector.getDBName());
                // System.exit(-3);
          }
          
          // se il risultato e' ancora null
          if (temporaneo==null){
              // viene lanciata un'eccezione
              System.err.println("Errore: nessun record trovato!");
//              RubricaException eccezione;
//              eccezione= new RubricaException("Non ho trovato nulla!",RubricaException.NOT_FOUND);
//              throw eccezione;
          } // end if (res==null)
          
          return listaPersone;
      } // end cercaPerNomeDB
      
      public Vector cercaPerCognome(String p_cognome) {
          Person temporaneo = null;
          Vector listaPersone = new Vector();
          String totalQuery = "SELECT FIRSTNAME, LASTNAME, CODE FROM PERSON where LASTNAME = ?";
          ResultSet rs;
          int numCols;
          int numRows;
          int row = 1;

          try {
                  // crea lo statement
                  PreparedStatement pstmt = dbConn.prepareStatement(totalQuery);
                  
                  // inserisce l'argomento, con i wildcard del DB agli estremi 
                  // (ricerca per sottostringa)
                  pstmt.setString(1,p_cognome);

                  // applica la query ed ottiene il resultset
                  rs = pstmt.executeQuery ();
                  
                  
                  // conta le colonne presenti
                  numCols = rs.getMetaData().getColumnCount();

                  // stampa i nomi delle colonne presenti su stdout
                  for (int col=1; col<=numCols; col++) {
                      System.out.print(rs.getMetaData().getColumnName(col) + " | ");      
                  }
                  System.out.println("|");
                  
                                  
                  //ricerca per tutto il resultset
                  // legge tutte le righe del ResultSet
                  while (rs.next()) {     
                      // costruisce l'oggetto Persona contenente i dati dell'ultimo record trovato
                      temporaneo = new Person(rs.getString(1),rs.getString(2),rs.getString(3));
                      /*
                      for (int col=1; col<=numCols; col++) {      
                            String string = rs.getString (col);
                            System.out.print(string + " | "); 
                          }
                          System.out.println("");
                          row ++;
                       */
                      listaPersone.add(temporaneo);
                  } // end while
                   
                  
          } catch (SQLException sqle) { // SQL exception
                System.err.println("Errore Fatale --- non possibile interrogare il DB:"+ dbConnector.getDBName());
                // System.exit(-3);
          }
          
          // se il risultato e' ancora null
          if (temporaneo==null){
              // viene lanciata un'eccezione
              System.err.println("Errore");
//              RubricaException eccezione;
//              eccezione= new RubricaException("Non ho trovato nulla!",RubricaException.NOT_FOUND);
//              throw eccezione;
          } // end if (res==null)
          
          return listaPersone;
      } // end cercaPerCognomeDB
      
      public Vector cercaPerCodice(String p_codice) {
          Person temporaneo = null;
          Vector listaPersone = new Vector();
          String totalQuery = "SELECT FIRSTNAME, LASTNAME, CODE FROM PERSON where CODE = ?";
          ResultSet rs;
          int numCols;
          int numRows;
          int row = 1;

          try {
                  // crea lo statement
                  PreparedStatement pstmt = dbConn.prepareStatement(totalQuery);
                  
                  // inserisce l'argomento, con i wildcard del DB agli estremi 
                  // (ricerca per sottostringa)
                  pstmt.setString(1,p_codice);

                  // applica la query ed ottiene il resultset
                  rs = pstmt.executeQuery ();
                  
                  
                  // conta le colonne presenti
                  numCols = rs.getMetaData().getColumnCount();

                  // stampa i nomi delle colonne presenti su stdout
                  for (int col=1; col<=numCols; col++) {
                      System.out.print(rs.getMetaData().getColumnName(col) + " | ");      
                  }
                  System.out.println("|");
                  
                                  
                  //ricerca per tutto il resultset
                  // legge tutte le righe del ResultSet
                  while (rs.next()) {     
                      // costruisce l'oggetto Persona contenente i dati dell'ultimo record trovato
                      temporaneo = new Person(rs.getString(1),rs.getString(2),rs.getString(3));
                      /*
                      for (int col=1; col<=numCols; col++) {      
                            String string = rs.getString (col);
                            System.out.print(string + " | "); 
                          }
                          System.out.println("");
                          row ++;
                       */
                      listaPersone.add(temporaneo);
                  } // end while
                   
                  
          } catch (SQLException sqle) { // SQL exception
                System.err.println("Errore Fatale --- non possibile interrogare il DB:"+ dbConnector.getDBName());
                // System.exit(-3);
          }
          
          // se il risultato e' ancora null
          if (temporaneo==null){
              // viene lanciata un'eccezione
              System.err.println("Errore");
//              RubricaException eccezione;
//              eccezione= new RubricaException("Non ho trovato nulla!",RubricaException.NOT_FOUND);
//              throw eccezione;
          } // end if (res==null)
          
          return listaPersone;
      } // end cercaPerCodice



} // end class QueryContainer
