
/*
 *
 * Created on 7 giugno 2005, 18.59
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */
package postgres;

import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.DriverManager;
import java.sql.SQLException;

/**
 * Esempio della classe Java per attivare una sessione con un DB Postgres 
 * 
 * 
 * @author Giulio Destri
 */
public class DbConnector {

    static Connection dbcon;

    private String DB_DRIVERNAME;  // nome del DB driver
    private String DB_URL;         // URL Per l'accesso al DB
    private String DB_DS_NAME;     // nome del data source
    private String DB_USERNAME;    // username per l'accesso al DB
    private String DB_PASSWORD;    // password per l'accesso al DB
    
/**
 * 
 * 
 */
    public  DbConnector() {        
        connectToDb();
    } 

/**
 * 
 * 
 * 
 * @return 
 */
    public Connection getConnection() {        
        return dbcon;
    } 

/**
 * connectToDB, si connette al DB usando i 5 parametri definiti come
 * attributi della classe
 * Creation date: (4/11/2002 11.46.52)
 * 
 */
    public void connectToDb() {        
        try {
            //Impostazione variabili per la stringa di connessione

            DB_DRIVERNAME = "org.postgresql.Driver";
            DB_URL = "jdbc:postgresql:";
            DB_DS_NAME = "//localhost:5432/giulio";
            DB_USERNAME = "giulio";
            DB_PASSWORD = "giulio";
            
            // determinazione del driver
	    Class.forName(DB_DRIVERNAME);
            // creazione della connessione
	    dbcon = DriverManager.getConnection(
		DB_URL+DB_DS_NAME, DB_USERNAME, DB_PASSWORD);
            
 	} catch (ClassNotFoundException cnfe) { // class exception: non si trova il driver
	      System.err.println("Errore Fatale --- non possibile caricare il driver "+DB_DRIVERNAME);
	      System.exit(-1); // il programma termina
	} catch (SQLException sqle) { // SQL exception: username o passwd errati
	      System.err.println("Errore Fatale --- non possibile connettere l'utente:"+DB_USERNAME+" al DB "+DB_URL+DB_DS_NAME);
              System.out.println("SQLException: " + sqle.getMessage()); 
              System.out.println("SQLState: " + sqle.getSQLState()); 
              System.out.println("VendorError: " + sqle.getErrorCode());
        }
	try {
            // determina informazioni sul database
            DatabaseMetaData dbmd= dbcon.getMetaData();
            // stampa le informazioni
            System.out.println(
                "Connesso a:"+ dbmd.getDatabaseProductName()+
                    	" "+ dbmd.getDatabaseProductVersion()+
		   " ["+DB_DS_NAME+"]\n");
	} catch (SQLException sqle) { // SQL exception: non si hanno info sul DB
            System.err.println("Errore fatale (2) --- non posso ottenere info sul database");
            System.out.println("SQLException: " + sqle.getMessage()); 
            System.out.println("SQLState: " + sqle.getSQLState()); 
            System.out.println("VendorError: " + sqle.getErrorCode());
	} // end catch
	
	System.gc();	// clean up della memoria  
            //System.exit(-1);
    } 
    
    public String getDBName(){
        return DB_DS_NAME;
    }    

 } // end class DbConnector
